<?php

namespace OrganizationsManagement\Controller;

use Exception;
use OrganizationsManagement\Traits\TResponse;
use Zeedhi\Framework\DTO;
use OrganizationsManagement\Service\RedirecionamentoProduto as RedirecionamentoProdutoService;

class RedirecionamentoProduto {

    use TResponse;

    /**
     * @var RedirecionamentoProdutoService
     */
    private $redirecionamentoProdutoService;

    /**
     * RedirecionamentoProdutoService constructor.
     * @param RedirecionamentoProdutoService $redirecionamentoProdutoService
     */
    public function __construct(RedirecionamentoProdutoService $redirecionamentoProdutoService)
    {
        $this->redirecionamentoProdutoService = $redirecionamentoProdutoService;
    }

    /**
     * @param DTO\Request $request
     * @param DTO\Response $response
     * @throws Exception
     */
    public function redirecionamentoProduto(DTO\Request $request, DTO\Response $response){
        try{
            $data = $this->redirecionamentoProdutoService->redirecionamentoProduto();
            $this->sendResponse($data, 200);
        }catch(Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveRedirecionamentoProduto(DTO\Request $request, DTO\Response $response){
        try {
            $param = $request->getParameters();
            $rows = $param['rows'];
            $stageRedirect = !empty($param['stageRedirect'])  ? $param['stageRedirect'] : null;
            $data = $this->redirecionamentoProdutoService->saveRedirecionamentoProduto($rows, $stageRedirect);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
