<?php

namespace OrganizationsManagement\Service;

use Doctrine\ORM\EntityManager;
use OrganizationsManagement\Repository\CallCategory as CallCategoryRepository;
use OrganizationsManagement\Util\InstanceProvider;

class CallCategory {
     /**
     * @var EntityManager
     */
    private $entityManager;
    /**
     * @var CallCategoryRepository
     */
    private $callCategoryRepository;

    public function __construct(EntityManager $entityManager,CallCategoryRepository $callCategoryRepository)
    {
        $this->entityManager = $entityManager;
        $this->callCategoryRepository = $callCategoryRepository;
    }

    public function findOrganization()
    {
        return $this->callCategoryRepository->findOrganization();
    }

    public function getCallCategory()
    {
        return $this->callCategoryRepository->getCallCategory();
    }

    public function getFindAssuntoCallCategory()
    {
        return $this->callCategoryRepository->getFindAssuntoCallCategory();
    }

    public function saveAssuntoCallCategory($data){
        
        $connection = InstanceProvider::getEntityManager()->getConnection();
        $connection->beginTransaction();

        try{   
            foreach ($data as $assunto) {
                $this->callCategoryRepository->saveAssuntoCallCategory($assunto);
            }
            $connection->commit();
        }catch(\Exception $e){
            $connection->rollBack();
            throw new \Exception($e->getMessage());
        }

    }
}