create or replace PROCEDURE REALOCAR_COMENSAIS_ESP_PAE (
    P_CDCENTRAL     IN VARCHAR2,
    P_CDFILIAL      IN VARCHAR2,
    P_CDTIPOCARD    IN VARCHAR2,
    P_CDSERVFILI    IN VARCHAR2,
    P_NRCARDPME     IN VARCHAR2,
    P_DTINICIAL     IN   DATE,
    P_DTFINAL       IN   DATE,
    P_IDPRATOS      IN VARCHAR2,
    P_ACRESCTIPOPRAT IN VARCHAR2,
    P_CDOPERADOR    IN VARCHAR2,
    P_NRLOGINTCARD  OUT  VARCHAR2
) IS
    V_IDUTRPADCA    VARCHAR2(1);
    V_DTPROC        DATE;
    V_DTINICIAL     DATE;
    V_PRODINATIVO   VARCHAR2(1) := '0';
    V_NRLOGINTCARD  VARCHAR2(20);
    V_EXISTNRCARDIAPME   VARCHAR2(10);
    V_EXISTPRATO VARCHAR2(10);
    V_QTCOMENSAIS  NUMBER;
    V_SUMQTCOMESP  NUMBER;
    V_COUNTTPPRAT NUMBER;
    V_NRCARDIAPMENOVO  VARCHAR2(20);
    V_NRCARDIAPME_CENT VARCHAR2(20);
    --P_CDSERVFILI VARCHAR2(100);
    V_QTDIABLOQCAR  NUMBER(2);
    V_IDUTILDTPROC  VARCHAR2(1);
    V_NO_DATA_FOUND    VARCHAR2(1);
    V_PRATO_ATIVO VARCHAR2(1);
    V_MAXNRSEQDEST     NUMBER;
    V_MAXNRORDDEST     NUMBER;
    V_CHANGED_COMENSAIS NUMBER;
    V_NRSEQPRACPME NUMBER;
    V_NRORDPRACPME NUMBER;
    V_NRSEQCNFCPME NUMBER;
    V_NRORDCNFCPME NUMBER;
    V_NRSEQCNFCPME_CARD NUMBER;
    V_NRORDCNFCPME_CARD NUMBER;
    V_LAST_REALOC VARCHAR2(10);
    V_LAST_AGREG VARCHAR2(4);
    V_HAS_PRATO_REF NUMBER;
    V_COUNT_HAS_REF NUMBER;
    V_COUNT_DEL NUMBER;
    V_NRSEQTMP NUMBER;
    V_IDPRATREALOC VARCHAR(2);

    V_QTCOMESTC        FLOAT;
    V_QTCLIESTC        FLOAT;
    V_QTFUNESTC        FLOAT;
    V_QTDOAESTC        FLOAT;

   V_QTCOMESTCPME        FLOAT;
   V_QTCLIESTCPME        FLOAT;
   V_QTFUNESTCPME        FLOAT;
   V_QTDOAESTCPME        FLOAT;

   V_TMP VARCHAR2(20);
   V_COUNT_TPPRAT NUMBER;
   V_SEQ NUMBER;
   V_TPPRATADDED NUMBER;

    PROCEDURE INSERE_LOG (
        P_CDOPERADOR IN VARCHAR2,
        P_NRLOGINTCARD  IN  NUMBER,
        P_CDCENTRAL  VARCHAR2,
        P_CDTIPOCARD    VARCHAR2,
        P_DTCARDIAPME   IN  DATE,
        P_CDSERVFILI    IN  VARCHAR2,
        P_CDFILIAL      IN  VARCHAR2,
        P_CDPRATO       IN  VARCHAR2,
        P_CDFILAUXPRAT  IN  VARCHAR2,
        P_CDPRODUTO     IN  VARCHAR2,
        P_ERRO          IN  NUMBER
    ) AS
    V_NRLOGINTCARD  VARCHAR2(20);
    BEGIN

        /*
			0 - Prato de destino inativo.
			1 - Prato de destino sem receita cadastrada.
			2 - Prato de destino sem receita ativa.
			3 - Prato de destino sem receita revisada.
			4 - Produto <CDARVPROD - NMPRODUTO> inativo na receita <padrao ou local ou tipo de cardapio ou servico> do prato de destino.
			5 - Intervalo de data fora do periodo permitido. Verifique a data de processamento.
		*/

		IF P_NRLOGINTCARD IS NULL THEN
			NOVO_CODIGO('LOGINTCARDPAE' || P_CDCENTRAL, V_NRLOGINTCARD, 1);
			V_NRLOGINTCARD := SUBSTR(V_NRLOGINTCARD, 11, 10);
		END IF;

        INSERT INTO LOGINTCARDPAE (
            NRLOGINTCARDPAE,
            CDFILCENTPME,
            CDTIPOCARD,
            DTCARDIAPME,
            CDSERVFILI,
            CDFILIAL,
            CDPRATO,
            CDFILAUXPRAT,
            CDPRODUTO,
            NRERRO,
            DTINCLUSAO,
            DTULTATU,
            CDOPERINCLUSAO,
            CDOPERULTATU
        ) VALUES (
            V_NRLOGINTCARD,
            P_CDCENTRAL,
            P_CDTIPOCARD,
            P_DTCARDIAPME,
            P_CDSERVFILI,
            P_CDFILIAL,
            P_CDPRATO,
            P_CDFILAUXPRAT,
            P_CDPRODUTO,
            P_ERRO,
            SYSDATE,
            SYSDATE,
            P_CDOPERADOR,
            P_CDOPERADOR
        );

    END;

    PROCEDURE INSERE_TMP (
        P_CDTMPCOMESPPRATPME IN VARCHAR2,
        P_NRSEQTMPCOMESPPRATPME IN NUMBER,
        P_CDREALCOMESPPRATPME IN VARCHAR2,
        P_CDFILCENTPME IN VARCHAR2,
        P_CDFILIAL IN VARCHAR2,
        P_CDTIPOCARD IN VARCHAR2,
        P_CDTIPOPRAT_REF IN VARCHAR2,
        P_CDPRATO_REF IN VARCHAR2,
        P_CDFILAUXPRAT_REF IN VARCHAR2,
        P_NRSEQPRACPME_REF IN NUMBER,
        P_CDCOMESPPRATPME IN VARCHAR2,
        P_CDTIPOPRAT_DEST IN VARCHAR2,
        P_CDPRATO_DEST IN VARCHAR2,
        P_CDFILAUXPRAT_DEST IN VARCHAR2,
        P_QTCOMESPRAT IN NUMBER,
        P_NRSEQCNFCPME IN NUMBER,
        P_NRORDCNFCPME IN NUMBER,
        P_DTCARDIA IN DATE,
        P_NRCARDIAPMEORIG IN VARCHAR2,
        P_NRCARDIAPMEDEST IN VARCHAR2
    ) AS
    V_COUNT  NUMBER;
    BEGIN
        SELECT COUNT(*)
        INTO V_COUNT
        FROM TMPCOMESPPRATPME
            WHERE CDTMPCOMESPPRATPME = P_CDTMPCOMESPPRATPME
            --AND NRSEQTMPCOMESPPRATPME = P_NRSEQTMPCOMESPPRATPME
            AND CDREALCOMESPPRATPME = P_CDREALCOMESPPRATPME
            AND CDFILCENTPME = P_CDFILCENTPME
            AND CDFILIAL = P_CDFILIAL
            AND CDTIPOCARD = P_CDTIPOCARD
            AND CDTIPOPRAT_REF = P_CDTIPOPRAT_REF
            AND CDPRATO_REF = P_CDPRATO_REF
            AND CDFILAUXPRAT_REF = P_CDFILAUXPRAT_REF
            AND CDCOMESPPRATPME = P_CDCOMESPPRATPME
            AND CDTIPOPRAT_DEST = P_CDTIPOPRAT_DEST
            AND CDPRATO_DEST = P_CDPRATO_DEST
            AND CDFILAUXPRAT_DEST = P_CDFILAUXPRAT_DEST
            AND DTCARDIA = P_DTCARDIA;

		IF (V_COUNT = 0) THEN
            INSERT INTO TMPCOMESPPRATPME(CDTMPCOMESPPRATPME, NRSEQTMPCOMESPPRATPME, CDREALCOMESPPRATPME, CDFILCENTPME, CDFILIAL, CDTIPOCARD, CDTIPOPRAT_REF, CDPRATO_REF, CDFILAUXPRAT_REF, NRSEQPRACPME_REF,
                    CDCOMESPPRATPME, CDTIPOPRAT_DEST, CDPRATO_DEST, CDFILAUXPRAT_DEST, QTCOMESPRAT, NRSEQCNFCPME, NRORDCNFCPME, DTCARDIA, NRCARDIAPMEORI, NRCARDIAPMEDEST)
            VALUES(P_CDTMPCOMESPPRATPME, P_NRSEQTMPCOMESPPRATPME, P_CDREALCOMESPPRATPME, P_CDFILCENTPME, P_CDFILIAL, P_CDTIPOCARD, P_CDTIPOPRAT_REF, P_CDPRATO_REF, P_CDFILAUXPRAT_REF, P_NRSEQPRACPME_REF,
                    P_CDCOMESPPRATPME, P_CDTIPOPRAT_DEST, P_CDPRATO_DEST, P_CDFILAUXPRAT_DEST, P_QTCOMESPRAT, P_NRSEQCNFCPME, P_NRORDCNFCPME, P_DTCARDIA, P_NRCARDIAPMEORIG, P_NRCARDIAPMEDEST);
        END IF;
    END;

BEGIN

    /* VERIFICA PARAMETRO UTILIZA RECEITA PADRAO NO CARDAPIO */
    SELECT
        NVL(IDUTRPADCA, 'N'),
        NVL(QTDIABLOQCAR, 0),
        NVL(IDUTILDTPROC, 'N')
    INTO
        V_IDUTRPADCA,
        V_QTDIABLOQCAR,
        V_IDUTILDTPROC
    FROM
        PARAMGERAL
    WHERE
        CDPARGERAL = '0001';

    /*TRATA DATA DE PROCESSAMENTO*/
    SELECT
        DECODE(V_IDUTILDTPROC, 'S', PF.DTPROCESSA, TRUNC(SYSDATE))
    INTO V_DTPROC
    FROM
        PARAMFILIAL PF
    WHERE
        PF.CDFILIAL = P_CDCENTRAL;

    IF ( V_DTPROC IS NULL ) THEN
        V_DTPROC := TRUNC(SYSDATE);
    ELSE
        V_DTPROC := V_DTPROC + V_QTDIABLOQCAR;
    END IF;

    IF ( P_DTINICIAL <= V_DTPROC ) THEN
        V_DTINICIAL := V_DTPROC;
        IF ( P_DTFINAL <= V_DTPROC ) THEN
            INSERE_LOG(P_CDOPERADOR, V_NRLOGINTCARD, P_CDCENTRAL, '', '', '',
                      '', '', '', '', 5);

            P_NRLOGINTCARD := NVL(V_NRLOGINTCARD, '');
            RETURN;
        END IF;

    ELSE
        V_DTINICIAL := P_DTINICIAL;

    END IF;

    /* TRATA APENAS OS TIPOS DE PRATOS PRIMEIRO, PARA ORGANIZAR NA TABELA TEMPORÁRIA O SEQUENCIAL DO TIPO DE PRATO DO PRATO DE DESTINO */
    /* É NECESSÁRIO PARA OS CASOS EM QUE O TIPO DE PRATO DESTINO É IGUAL O DE ORIGEM E EXISTE MAIS DE UMA ORIGEM COM O MESMO TIPO DE PRATO IGUAL */
    NOVO_CODIGO('TMPCOMESPPRATPME', V_TMP, 1);
    V_TMP := SUBSTR(V_TMP, 11, 10);
    V_LAST_AGREG := NULL;
    V_SEQ := 0;
    V_TPPRATADDED := 0;
    --FOR C_DATES IN ( SELECT DT.DTDATA FROM DATA DT WHERE ( DT.DTDATA BETWEEN V_DTINICIAL AND P_DTFINAL )) LOOP

    FOR C_REALOC IN(
        SELECT 
            R.CDREALCOMESPPRATPME,
            R.CDFILCENTPME,
            R.CDFILIAL,
            R.CDTIPOCARD,
            R.CDTIPOPRAT,
            R.CDPRATO,
            R.CDFILAUXPRAT
        FROM REALCOMESPPRATPME R
        WHERE R.CDFILCENTPME = P_CDCENTRAL
            AND (INSTR(NVL(P_CDFILIAL, R.CDFILIAL), R.CDFILIAL) > 0)
            AND R.CDTIPOCARD = P_CDTIPOCARD
            AND EXISTS ( SELECT 1 FROM COMESPPRATPME C WHERE C.CDREALCOMESPPRATPME = R.CDREALCOMESPPRATPME)
        ORDER BY R.CDTIPOPRAT, R.CDFILIAL, R.CDTIPOCARD, R.CDPRATO, R.CDFILAUXPRAT
    ) LOOP 
        FOR C_DATES IN ( 
            SELECT DT.DTDATA,
                P.NRSEQPRACPME,
                P.NRORDPRACPME,
                P.NRCARDIAPME
            FROM DATA DT 
                    JOIN CARDIAPME CD
                        ON CD.DTCARDIAPME = DT.DTDATA
                        AND (CD.CDFILCENTPME = P_CDCENTRAL)              AND
                           (CD.CDFILIAL    = P_CDCENTRAL)        AND
                           (CD.NRCARDPME    = P_NRCARDPME)                AND
                           (CD.CDSERVFILI  = P_CDSERVFILI)
                    JOIN COMPCARDPME P 
                           ON P.NRCARDIAPME = CD.NRCARDIAPME 
            WHERE P.CDFILCENTPME = P_CDCENTRAL
                AND P.NRCARDPME = P_NRCARDPME
                AND P.CDPRATO = C_REALOC.CDPRATO
                AND P.CDFILAUXPRAT = C_REALOC.CDFILAUXPRAT
                AND P.CDTIPOPRAT = C_REALOC.CDTIPOPRAT    
                AND DT.DTDATA BETWEEN V_DTINICIAL AND P_DTFINAL 
        ) LOOP
            FOR C_COMESP IN (
                SELECT
                    C.CDCOMESPPRATPME,
                    C.CDTIPOPRAT,
                    C.CDPRATO,
                    C.CDFILAUXPRAT,
                    C.QTCOMESPRAT,
                    C.CDREALCOMESPPRATPME
                FROM COMESPPRATPME C 
                WHERE C.CDREALCOMESPPRATPME = C_REALOC.CDREALCOMESPPRATPME
                AND PRATO_RECEITA_ATIVA(C.CDPRATO, C.CDFILAUXPRAT, C_REALOC.CDFILIAL, P_CDSERVFILI, NULL, P_CDCENTRAL, P_CDTIPOCARD) = 'S'              
                AND C.CDTIPOPRAT || C.CDPRATO || C.CDFILAUXPRAT NOT IN (
                    SELECT CDTIPOPRAT || CDPRATO || CDFILAUXPRAT
                    FROM CARDIAPME CD
                         JOIN COMPCARDPME P 
                           ON P.NRCARDIAPME = CD.NRCARDIAPME 
                           AND P.CDFILCENTPME = P_CDCENTRAL
                           AND P.NRCARDPME = P_NRCARDPME
                        WHERE CD.DTCARDIAPME = C_DATES.DTDATA
                        AND (CD.CDFILCENTPME = P_CDCENTRAL)              AND
                           (CD.CDFILIAL    = C_REALOC.CDFILIAL)        AND
                           (CD.NRCARDPME    = P_NRCARDPME)                AND
                           (CD.CDSERVFILI  = P_CDSERVFILI)                   
                        AND NVL(P.IDPRATREALOC, 'N') = 'S'
                )
                ORDER BY C.CDTIPOPRAT, C.CDPRATO, C.CDFILAUXPRAT
            ) LOOP  
                V_SEQ := V_SEQ + 1;
                IF (P_ACRESCTIPOPRAT = 'S') THEN
                    /* Verifica se existe o tipo de prato na tabela temp */
                    BEGIN
                        SELECT MAX(NRSEQCNFCPME), MAX(NRORDCNFCPME)
                        INTO V_NRSEQCNFCPME_CARD, V_NRORDCNFCPME_CARD
                        FROM TMPCOMESPPRATPME T 
                        WHERE T.CDFILCENTPME = P_CDCENTRAL
                        --AND T.CDFILIAL = C_REALOC.CDFILIAL
                        AND T.CDTIPOCARD = C_REALOC.CDTIPOCARD
                        AND T.CDTIPOPRAT_DEST = C_COMESP.CDTIPOPRAT
                        AND T.CDTMPCOMESPPRATPME = V_TMP;
                    EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                        V_NRSEQCNFCPME_CARD := NULL;
                        V_NRORDCNFCPME_CARD := NULL;
                    END;

                    IF (V_NRSEQCNFCPME_CARD IS NOT NULL) THEN
                        /* Se existir verifica se existe algum tipo de prato de mesmo código já é utilizado na agregada */
                        BEGIN
                            SELECT MIN(NRSEQCNFCPME), MIN(NRORDCNFCPME)
                            INTO V_NRSEQCNFCPME, V_NRORDCNFCPME
                            FROM TMPCOMESPPRATPME T 
                            WHERE T.CDFILCENTPME = P_CDCENTRAL
                            AND (T.CDFILIAL <> C_REALOC.CDFILIAL OR T.DTCARDIA <> C_DATES.DTDATA)
                            AND T.CDTIPOCARD = C_REALOC.CDTIPOCARD
                            AND T.CDTIPOPRAT_DEST = C_COMESP.CDTIPOPRAT
                            AND T.CDTMPCOMESPPRATPME = V_TMP
                            AND T.NRSEQCNFCPME NOT IN (SELECT NRSEQCNFCPME FROM TMPCOMESPPRATPME T3 WHERE T3.CDTMPCOMESPPRATPME = V_TMP AND T3.CDFILIAL = C_REALOC.CDFILIAL AND T3.DTCARDIA = C_DATES.DTDATA AND T3.CDTIPOPRAT_DEST = C_COMESP.CDTIPOPRAT)
                            AND T.NRORDCNFCPME >= C_DATES.NRORDPRACPME + (SELECT COUNT(DISTINCT NRORDCNFCPME) + 1
                                                                            FROM TMPCOMESPPRATPME T WHERE T.CDFILCENTPME = P_CDCENTRAL
                                                                                AND T.CDTIPOCARD = C_REALOC.CDTIPOCARD
                                                                                AND T.CDTMPCOMESPPRATPME = V_TMP
                                                                                AND T.DTCARDIA = C_DATES.DTDATA
                                                                                AND NRORDCNFCPME < C_DATES.NRORDPRACPME);                   
                        EXCEPTION
                            WHEN NO_DATA_FOUND THEN
                            V_NRSEQCNFCPME := NULL;
                            V_NRORDCNFCPME := NULL;
                        END;

                        --AND (V_LAST_AGREG = NULL OR V_LAST_AGREG = C_REALOC.CDFILIAL
                        IF ((V_NRSEQCNFCPME IS NOT NULL)) THEN
                            /* Se existir um tipo de prato de mesmo código já utilizado na agregada, pega o ultimo sequencial utilizado na temp */

                            INSERE_TMP(V_TMP, V_SEQ, C_COMESP.CDREALCOMESPPRATPME, C_REALOC.CDFILCENTPME, C_REALOC.CDFILIAL, C_REALOC.CDTIPOCARD, C_REALOC.CDTIPOPRAT, C_REALOC.CDPRATO, C_REALOC.CDFILAUXPRAT, C_DATES.NRSEQPRACPME,
                                C_COMESP.CDCOMESPPRATPME, C_COMESP.CDTIPOPRAT, C_COMESP.CDPRATO, C_COMESP.CDFILAUXPRAT, C_COMESP.QTCOMESPRAT, V_NRSEQCNFCPME, V_NRORDCNFCPME, C_DATES.DTDATA, C_DATES.NRCARDIAPME, NULL);
                        ELSE 
                            /* Se não existir um tipo de prato de mesmo código já utilizado na agregada, significa que o mesmo foi criado para outra agregada
                                e pode ser reaproveitado para esta, portanto seleciona o sequencial minimo do tipo de prato da agregada que não é a atual */

                            SELECT COUNT(DISTINCT NRORDCNFCPME) + 1
                            INTO V_TPPRATADDED
                            FROM TMPCOMESPPRATPME T WHERE T.CDFILCENTPME = P_CDCENTRAL
                                --AND T.CDFILIAL = C_REALOC.CDFILIAL
                                AND T.CDTIPOCARD = C_REALOC.CDTIPOCARD
                                --AND T.CDTIPOPRAT_REF = C_REALOC.CDTIPOPRAT
                                AND T.CDTMPCOMESPPRATPME = V_TMP;

                                SELECT MAX(NRSEQCNFCPME) + V_TPPRATADDED
                                INTO V_NRSEQCNFCPME
                                FROM CONFCARDPME 
                             WHERE CDFILCENTPME = P_CDCENTRAL AND NRCARDPME    = P_NRCARDPME AND CDSERVFILI   = P_CDSERVFILI;

                            SELECT COUNT(DISTINCT NRORDCNFCPME) + 1
                            INTO V_TPPRATADDED
                            FROM TMPCOMESPPRATPME T WHERE T.CDFILCENTPME = P_CDCENTRAL
                                AND T.CDTIPOCARD = C_REALOC.CDTIPOCARD
                                AND T.CDTMPCOMESPPRATPME = V_TMP
                                AND NRORDCNFCPME < C_DATES.NRORDPRACPME + V_TPPRATADDED;                  

                            --NRSEQCNFCPME = NRSEQCNFCPME + 1,
                            /*UPDATE TMPCOMESPPRATPME SET NRORDCNFCPME = NRORDCNFCPME + 1 WHERE CDFILCENTPME = P_CDCENTRAL
                                AND CDTIPOCARD = C_REALOC.CDTIPOCARD
                                AND CDTMPCOMESPPRATPME = V_TMP
                                --AND CDFILIAL <> C_REALOC.CDFILIAL
                                --AND NRSEQCNFCPME >= C_REALOC.NRORDPRACPME + V_TPPRATADDED
                                AND NRORDCNFCPME >=  C_REALOC.NRORDPRACPME + V_TPPRATADDED;*/

                             INSERE_TMP(V_TMP, V_SEQ, C_COMESP.CDREALCOMESPPRATPME, C_REALOC.CDFILCENTPME, C_REALOC.CDFILIAL, C_REALOC.CDTIPOCARD, C_REALOC.CDTIPOPRAT, C_REALOC.CDPRATO, C_REALOC.CDFILAUXPRAT, C_DATES.NRSEQPRACPME,
                                C_COMESP.CDCOMESPPRATPME, C_COMESP.CDTIPOPRAT, C_COMESP.CDPRATO, C_COMESP.CDFILAUXPRAT, C_COMESP.QTCOMESPRAT, V_NRSEQCNFCPME, C_DATES.NRORDPRACPME + V_TPPRATADDED, C_DATES.DTDATA, C_DATES.NRCARDIAPME, NULL);
                        END IF;
                    ELSE
                        /* Se não existir o tipo de prato na tabela temp, insere como tipo de prato após o de origem na tabela original e atualiza os demais para respeitar a ordem */

                        SELECT COUNT(DISTINCT NRORDCNFCPME) + 1
                            INTO V_TPPRATADDED
                            FROM TMPCOMESPPRATPME T WHERE T.CDFILCENTPME = P_CDCENTRAL AND T.CDTIPOCARD = C_REALOC.CDTIPOCARD AND T.CDTMPCOMESPPRATPME = V_TMP;

                                SELECT MAX(NRSEQCNFCPME) + V_TPPRATADDED
                                INTO V_NRSEQCNFCPME
                                FROM CONFCARDPME 
                             WHERE CDFILCENTPME = P_CDCENTRAL AND NRCARDPME    = P_NRCARDPME AND CDSERVFILI   = P_CDSERVFILI; 

                         SELECT COUNT(DISTINCT NRORDCNFCPME) + 1
                            INTO V_TPPRATADDED
                            FROM TMPCOMESPPRATPME T WHERE T.CDFILCENTPME = P_CDCENTRAL
                                AND T.CDTIPOCARD = C_REALOC.CDTIPOCARD
                                AND T.CDTMPCOMESPPRATPME = V_TMP
                                AND NRORDCNFCPME < C_DATES.NRORDPRACPME + V_TPPRATADDED;

                         --NRSEQCNFCPME = NRSEQCNFCPME + 1,
                        /*UPDATE TMPCOMESPPRATPME SET NRORDCNFCPME = NRORDCNFCPME + 1 WHERE CDFILCENTPME = P_CDCENTRAL
                                AND CDTIPOCARD = C_REALOC.CDTIPOCARD
                                AND CDTMPCOMESPPRATPME = V_TMP
                                --AND CDFILIAL <> C_REALOC.CDFILIAL
                                --AND NRSEQCNFCPME >= C_REALOC.NRORDPRACPME + V_TPPRATADDED
                                AND NRORDCNFCPME >=  C_REALOC.NRORDPRACPME + V_TPPRATADDED;*/

                        INSERE_TMP(V_TMP, V_SEQ, C_COMESP.CDREALCOMESPPRATPME, C_REALOC.CDFILCENTPME, C_REALOC.CDFILIAL, C_REALOC.CDTIPOCARD, C_REALOC.CDTIPOPRAT, C_REALOC.CDPRATO, C_REALOC.CDFILAUXPRAT, C_DATES.NRSEQPRACPME,
                                C_COMESP.CDCOMESPPRATPME, C_COMESP.CDTIPOPRAT, C_COMESP.CDPRATO, C_COMESP.CDFILAUXPRAT, C_COMESP.QTCOMESPRAT, V_NRSEQCNFCPME, C_DATES.NRORDPRACPME + V_TPPRATADDED, C_DATES.DTDATA, C_DATES.NRCARDIAPME, NULL);
                    END IF;
                ELSE
                    SELECT NRSEQCNFCPME, NRORDCNFCPME
                    INTO V_NRSEQCNFCPME, V_NRORDCNFCPME
                    FROM CONFCARDPME C
                    WHERE CDFILCENTPME = P_CDCENTRAL
                     AND NRCARDPME    = P_NRCARDPME
                     AND CDSERVFILI   = P_CDSERVFILI
                     AND CDTIPOPRAT   = C_COMESP.CDTIPOPRAT
                     AND NRSEQCNFCPME = ( SELECT MAX(NRSEQCNFCPME) 
                                            FROM CONFCARDPME C2 
                                           WHERE C2.CDFILCENTPME = C.CDFILCENTPME AND C2.NRCARDPME = C.NRCARDPME 
                                             AND C2.CDSERVFILI = C.CDSERVFILI AND C2.CDTIPOPRAT = C.CDTIPOPRAT);
                    IF (V_NRSEQCNFCPME IS NOT NULL) THEN
                        INSERE_TMP(V_TMP, V_SEQ, C_COMESP.CDREALCOMESPPRATPME, C_REALOC.CDFILCENTPME, C_REALOC.CDFILIAL, C_REALOC.CDTIPOCARD, C_REALOC.CDTIPOPRAT, C_REALOC.CDPRATO, C_REALOC.CDFILAUXPRAT, C_DATES.NRSEQPRACPME,
                            C_COMESP.CDCOMESPPRATPME, C_COMESP.CDTIPOPRAT, C_COMESP.CDPRATO, C_COMESP.CDFILAUXPRAT, C_COMESP.QTCOMESPRAT, V_NRSEQCNFCPME, V_NRORDCNFCPME,C_DATES.DTDATA, C_DATES.NRCARDIAPME, NULL);
                    END IF;                
                END IF;
            END LOOP;  
        END LOOP;
    END LOOP;
    --END LOOP;
    COMMIT;

    V_NRSEQCNFCPME := NULL;
    V_NRORDCNFCPME := NULL;
    V_LAST_REALOC := NULL;
    /* PERCORRE REGISTROS DE REALOCAÇÃO DE COMENSAIS */
    FOR C_REALOC IN (
        SELECT
            R.CDREALCOMESPPRATPME,
            R.CDFILCENTPME,
            R.CDFILIAL,
            R.CDTIPOCARD,
            R.CDTIPOPRAT AS CDTIPOPRAT_REF,
            R.CDPRATO AS CDPRATO_REF,
            R.CDFILAUXPRAT AS CDFILAUXPRAT_REF,
            C.CDCOMESPPRATPME,
            C.CDTIPOPRAT AS CDTIPOPRAT_DEST,
            C.CDPRATO AS CDPRATO_DEST,
            C.CDFILAUXPRAT AS CDFILAUXPRAT_DEST,
            C.QTCOMESPRAT,
            NVL(RECEITA_UTILIZADA(C.CDPRATO, C.CDFILAUXPRAT, R.CDFILIAL, P_CDSERVFILI, P_CDCENTRAL, P_CDTIPOCARD), 'N') AS TIPO_RECE,
            PRATO_RECEITA_ATIVA(C.CDPRATO, C.CDFILAUXPRAT, R.CDFILIAL, P_CDSERVFILI, NULL, P_CDCENTRAL, P_CDTIPOCARD) AS PRATO_RECEITA_ATIVA
        FROM
             REALCOMESPPRATPME R
             JOIN COMESPPRATPME C 
              ON C.CDREALCOMESPPRATPME = R.CDREALCOMESPPRATPME
        WHERE
            CDFILCENTPME = P_CDCENTRAL
            AND (INSTR(NVL(P_CDFILIAL, CDFILIAL), CDFILIAL) > 0)
            AND CDTIPOCARD = P_CDTIPOCARD
        ORDER BY R.CDTIPOPRAT, R.CDTIPOCARD, R.CDFILIAL,  R.CDPRATO, R.CDFILAUXPRAT, C.CDTIPOPRAT, C.CDCOMESPPRATPME, C.CDPRATO, C.CDFILAUXPRAT
    ) LOOP

        SELECT
            NVL(IDATIVO, 'S')
            INTO V_PRATO_ATIVO
        FROM
            PRATO
        WHERE
                CDPRATO = C_REALOC.CDPRATO_DEST
            AND CDFILAUXPRAT = C_REALOC.CDFILAUXPRAT_DEST;

        IF ( V_PRATO_ATIVO = 'N' ) THEN
            /* 0 - Prato inativo */
            INSERE_LOG(P_CDOPERADOR, V_NRLOGINTCARD, P_CDCENTRAL, '', '', '',
                      '', C_REALOC.CDPRATO_DEST, C_REALOC.CDFILAUXPRAT_DEST, '',
                      0);
            P_NRLOGINTCARD := NVL(V_NRLOGINTCARD, '');
            CONTINUE;
        END IF;

        IF ( C_REALOC.TIPO_RECE = 'N' OR C_REALOC.TIPO_RECE IS NULL) THEN
            /* 1 - Prato sem receita cadastrada */
            INSERE_LOG(P_CDOPERADOR, V_NRLOGINTCARD, P_CDCENTRAL, '', '', '',
                      '', C_REALOC.CDPRATO_DEST, C_REALOC.CDFILAUXPRAT_DEST, '',
                      1);
            P_NRLOGINTCARD := NVL(V_NRLOGINTCARD, '');
            CONTINUE;
        END IF;

        IF ( C_REALOC.PRATO_RECEITA_ATIVA = 'N' OR C_REALOC.PRATO_RECEITA_ATIVA IS NULL) THEN
            /* 2 - Prato sem receita ativa */
            INSERE_LOG(P_CDOPERADOR, V_NRLOGINTCARD, P_CDCENTRAL, '', '', '',
                      '', C_REALOC.CDPRATO_DEST, C_REALOC.CDFILAUXPRAT_DEST, '',
                      2);
            P_NRLOGINTCARD := NVL(V_NRLOGINTCARD, '');
            CONTINUE;
        ELSE
            IF (
                C_REALOC.TIPO_RECE = 'P'
                AND V_IDUTRPADCA = 'N'
            ) THEN
			  /* 3- Prato de destino sem receita revisada */
                INSERE_LOG(P_CDOPERADOR, V_NRLOGINTCARD, C_REALOC.CDFILCENTPME, C_REALOC.CDTIPOCARD, '',
                          P_CDSERVFILI,
                          C_REALOC.CDFILIAL,
                          C_REALOC.CDPRATO_DEST,
                          C_REALOC.CDFILAUXPRAT_DEST,
                          '',
                          3);

				P_NRLOGINTCARD := NVL(V_NRLOGINTCARD, '');
                CONTINUE;

            ELSE
                /* Verifica se possui insumo inativo */
                V_PRODINATIVO := '0';
                IF ( C_REALOC.TIPO_RECE = 'S' ) THEN  /*RECEITA POR SERVICO COM PRODUTO INATIVO*/
                    FOR C_RECESERV IN (
                        SELECT
                            P.CDPRODUTO,
                            P.IDPRODATIVPR,
                            PF.IDPRODATIV
                        FROM
                                 RECESERV RS
                            INNER JOIN PRODUTO   P ON P.CDPRODUTO = RS.CDPRODUTO
                                                    AND P.IDPRODATIVPR = 'N'
                            LEFT JOIN PRODFILI  PF ON PF.CDPRODUTO = P.CDPRODUTO
                                                     AND PF.CDFILIAL = C_REALOC.CDFILIAL
                                                     AND PF.IDPRODATIV = 'I'
                        WHERE
                                RS.CDFILIAL = C_REALOC.CDFILIAL
                            AND RS.CDSERVFILI = P_CDSERVFILI
                            AND RS.CDPRATO = C_REALOC.CDPRATO_DEST
                            AND RS.CDFILAUXPRAT = C_REALOC.CDFILAUXPRAT_DEST
                    ) LOOP
                        V_PRODINATIVO := '1';
						/*4 - Produto <CDARVPROD - NMPRODUTO> inativo na receita <padrao ou local ou tipo de cardapio ou servico> do prato de destino.*/
                        INSERE_LOG(P_CDOPERADOR, V_NRLOGINTCARD, C_REALOC.CDFILCENTPME, '', '',
                                  P_CDSERVFILI,
                                  C_REALOC.CDFILIAL,
                                  C_REALOC.CDPRATO_DEST,
                                  C_REALOC.CDFILAUXPRAT_DEST,
                                  C_RECESERV.CDPRODUTO,
                                  4);

                    END LOOP;

                END IF;

                IF ( C_REALOC.TIPO_RECE = 'F' ) THEN  /*RECEITA LOCAL COM PRODUTO INATIVO*/
                    FOR C_RECEFILI IN (
                        SELECT
                            P.CDPRODUTO,
                            P.IDPRODATIVPR,
                            PF.IDPRODATIV
                        FROM
                                 RECEFILI RF
                            INNER JOIN PRODUTO   P ON P.CDPRODUTO = RF.CDPRODUTO
                                                    AND P.IDPRODATIVPR = 'N'
                            LEFT JOIN PRODFILI  PF ON PF.CDPRODUTO = P.CDPRODUTO
                                                     AND PF.CDFILIAL = RF.CDFILIAL
                                                     AND PF.IDPRODATIV = 'I'
                        WHERE
                                RF.CDFILIAL = C_REALOC.CDFILIAL
                            AND RF.CDPRATO = C_REALOC.CDPRATO_DEST
                            AND RF.CDFILAUXPRAT = C_REALOC.CDFILAUXPRAT_DEST
                    ) LOOP
                        V_PRODINATIVO := '1';
						/*4 - Produto <CDARVPROD - NMPRODUTO> inativo na receita <padrao ou local ou tipo de cardapio ou servico> do prato de destino.*/
                        INSERE_LOG(P_CDOPERADOR, V_NRLOGINTCARD, C_REALOC.CDFILCENTPME, '', '', '',
                                  C_REALOC.CDFILIAL,
                                  C_REALOC.CDPRATO_DEST,
                                  C_REALOC.CDFILAUXPRAT_DEST,
                                  C_RECEFILI.CDPRODUTO,
                                  4);

                    END LOOP;
                END IF;

                IF ( C_REALOC.TIPO_RECE = 'T' ) THEN   /*RECEITA TIPO DE CARDAPIO COM PRODUTO INATIVO*/
                    FOR C_RECETPCARD IN (
                        SELECT
                            P.CDPRODUTO,
                            P.IDPRODATIVPR,
                            PF.IDPRODATIV
                        FROM
                                 RECETPCARD RT
                            INNER JOIN PRODUTO   P ON P.CDPRODUTO = RT.CDPRODUTO
                                                    AND P.IDPRODATIVPR = 'N'
                            LEFT JOIN PRODFILI  PF ON PF.CDPRODUTO = P.CDPRODUTO
                                                     AND PF.CDFILIAL = RT.CDFILCENTPME
                                                     AND PF.IDPRODATIV = 'I'
                        WHERE
                                RT.CDFILCENTPME = C_REALOC.CDFILCENTPME
                            AND RT.CDTIPOCARD = C_REALOC.CDTIPOCARD
                            AND RT.CDPRATO = C_REALOC.CDPRATO_DEST
                            AND RT.CDFILAUXPRAT = C_REALOC.CDFILAUXPRAT_DEST
                            AND RT.CDPRODUTO = P.CDPRODUTO
                    ) LOOP
                        V_PRODINATIVO := '1';
						/*4 - Produto <CDARVPROD - NMPRODUTO> inativo na receita <padrao ou local ou tipo de cardapio ou servico> do prato de destino.*/
                        INSERE_LOG(P_CDOPERADOR, V_NRLOGINTCARD, C_REALOC.CDFILCENTPME, C_REALOC.CDTIPOCARD, '',
                                  '',
                                  '',
                                  C_REALOC.CDPRATO_DEST,
                                  C_REALOC.CDFILAUXPRAT_DEST,
                                  C_RECETPCARD.CDPRODUTO,
                                  4);

                    END LOOP;
                END IF;

                IF ( C_REALOC.TIPO_RECE = 'P' ) THEN   /*RECEITA PADRAO COM PRODUTO INATIVO*/
                    FOR C_RECEPADR IN (
                        SELECT
                            P.CDPRODUTO,
                            P.IDPRODATIVPR,
                            PF.IDPRODATIV
                        FROM
                                 RECEPADR RP
                            INNER JOIN PRODUTO   P ON P.CDPRODUTO = RP.CDPRODUTO
                                                    AND P.IDPRODATIVPR = 'N'
                            LEFT JOIN PRODFILI  PF ON PF.CDPRODUTO = P.CDPRODUTO
                                                     AND PF.IDPRODATIV = 'I'
                        WHERE
                                RP.CDPRATO = C_REALOC.CDPRATO_DEST
                            AND RP.CDFILAUXPRAT = C_REALOC.CDFILAUXPRAT_DEST
                            AND RP.CDPRODUTO = P.CDPRODUTO
                    ) LOOP
                        V_PRODINATIVO := '1';
						/*4 - Produto <CDARVPROD - NMPRODUTO> inativo na receita <padrao ou local ou tipo de cardapio ou servico> do prato de destino.*/
                        INSERE_LOG(P_CDOPERADOR, V_NRLOGINTCARD, C_REALOC.CDFILCENTPME, '', '', '',
                                  '',
                                  C_REALOC.CDPRATO_DEST,
                                  C_REALOC.CDFILAUXPRAT_DEST,
                                  C_RECEPADR.CDPRODUTO,
                                  4);

                    END LOOP;
                END IF;

                IF ( V_PRODINATIVO = '0' ) THEN
                    /* Finalizada validações do prato e da receita começa a rotina */
                    FOR C_DATAS IN (
                        SELECT DT.DTDATA AS DTCARDIAPME, CUSTPADTCARD.VRCUSPADTCAR, DECODE(PARAMPLANEJA.IDCARDIAUTIL, 'S', FERIFILI.DTFERIFILI) AS DTFERIFILI,
                            FERIFILI.DSFERIFILI, PARAMPLANEJA.NRCORNUTIL, CD.NRCARDIAPME AS NRCARDIA_CENTRAL
                            FROM DATA DT LEFT JOIN FERIFILI 
                            ON ( FERIFILI.CDFILIAL =C_REALOC.CDFILIAL ) AND ( FERIFILI.DTFERIFILI = DT.DTDATA )
                            INNER JOIN PARAMPLANEJA ON PARAMPLANEJA.CDFILIAL =C_REALOC.CDFILIAL AND PARAMPLANEJA.CDPARPLANEJA = '1' 
                            LEFT JOIN CUSTPADTCARD ON ( CDFILCENTPME =P_CDCENTRAL ) AND ( CDTIPOCARD =C_REALOC.CDTIPOCARD ) 
                            AND ( CDSERVFILI =P_CDSERVFILI ) AND ( DTREFCUSTCAR = ( 
                                SELECT MAX(DTREFCUSTCAR) FROM CUSTPADTCARD WHERE CDFILCENTPME =P_CDCENTRAL AND CDTIPOCARD =C_REALOC.CDTIPOCARD 
                                AND CDSERVFILI =P_CDSERVFILI AND DTREFCUSTCAR <= DTDATA ) ) 
                            JOIN CARDIAPME CD
                                ON CD.DTCARDIAPME = DT.DTDATA
                                AND (CD.CDFILCENTPME = P_CDCENTRAL)              AND
                                   (CD.CDFILIAL    = P_CDCENTRAL)        AND
                                   (CD.NRCARDPME    = P_NRCARDPME)                AND
                                   (CD.CDSERVFILI  = P_CDSERVFILI)     
                                AND EXISTS (SELECT 1 FROM COMPCARDPME P WHERE P.CDFILCENTPME = CD.CDFILCENTPME
                                            AND P.NRCARDPME = CD.NRCARDPME
                                            AND P.NRCARDIAPME = CD.NRCARDIAPME
                                            AND P.CDPRATO = C_REALOC.CDPRATO_REF
                                            AND P.CDFILAUXPRAT = C_REALOC.CDFILAUXPRAT_REF
                                            AND P.CDTIPOPRAT = C_REALOC.CDTIPOPRAT_REF)
                            WHERE ( DT.DTDATA BETWEEN V_DTINICIAL AND P_DTFINAL ) 
                                AND ((CUSTPADTCARD.VRCUSPADTCAR IS NOT NULL AND PARAMPLANEJA.IDCUSPADCAR = 'S') OR PARAMPLANEJA.IDCUSPADCAR = 'N')
                            ORDER BY DT.DTDATA
                    ) LOOP

                        /* CHECA SE EXISTE CARDÁPIO ESPECÍFICO PARA A AGREGADA NA DATA*/
                        V_EXISTNRCARDIAPME := NULL;
                        BEGIN

                            SELECT CD.NRCARDIAPME, NVL(CD.QTCOMESTCPME, 0)
                            INTO V_EXISTNRCARDIAPME, V_QTCOMESTC
                             FROM CARDAPIOPME C, CARDIAPME CD
                             WHERE (C.CDFILCENTPME = P_CDCENTRAL)              AND
                                   (C.CDTIPOCARD   = C_REALOC.CDTIPOCARD)      AND
                                   (CD.CDFILIAL    = C_REALOC.CDFILIAL)        AND
                                   (C.CDFILCENTPME = CD.CDFILCENTPME)             AND
                                   (C.NRCARDPME    = CD.NRCARDPME)                AND
                                   (CD.CDFILIAL    <> CD.CDFILCENTPME)            AND
                                   (CD.CDSERVFILI  = P_CDSERVFILI)      AND
                                   (CD.DTCARDIAPME = C_DATAS.DTCARDIAPME) AND
                                   C.NRCARDPME = P_NRCARDPME AND
                                   CD.IDCARDESPEC = 'S';

                        EXCEPTION
                            WHEN No_Data_Found Then
                              V_EXISTNRCARDIAPME := NULL;
                        END;

                        /* Caso não exista cardapio específico para o periodo cria um novo */
                        IF V_EXISTNRCARDIAPME IS NULL THEN
                            BEGIN
                                SELECT NRCARDIAPME, QTCOMESTCPME, QTCLIESTCPME, QTFUNESTCPME, QTDOAESTCPME
                                INTO V_NRCARDIAPMENOVO, V_QTCOMESTC, V_QTCLIESTC, V_QTFUNESTC, V_QTDOAESTC
                                 FROM CARDIAPME CD
                                 WHERE (CD.CDFILCENTPME = P_CDCENTRAL)              AND
                                       (CD.CDFILIAL    = C_REALOC.CDFILIAL)        AND
                                       (CD.NRCARDPME    = P_NRCARDPME)                AND
                                       (CD.CDSERVFILI  = P_CDSERVFILI)      AND
                                       (CD.DTCARDIAPME = C_DATAS.DTCARDIAPME) AND
                                       CD.NRCARDPME = P_NRCARDPME AND 
                                       CD.IDCARDESPEC <> 'S';

                            EXCEPTION
                                WHEN No_Data_Found Then
                                  V_NRCARDIAPMENOVO := NULL;
                                  V_QTCOMESTC := NULL;
                                  V_QTCLIESTC := NULL;
                                  V_QTFUNESTC := NULL;
                                  V_QTDOAESTC := NULL;
                            END;

                            IF (NOT V_QTCOMESTC IS NULL) AND (V_QTCOMESTC > 0) THEN 										
                                --IF V_NRCARDIAPMENOVO IS NOT NULL THEN 

                                UPDATE CARDIAPME SET QTCOMESTCPME = V_QTCOMESTC, QTCLIESTCPME = V_QTCLIESTC,
                                           QTFUNESTCPME = V_QTFUNESTC, QTDOAESTCPME = V_QTDOAESTC, QTCOMEFECPME = 0, QTCLIEFECPME = 0,
                                           QTFUNEFECPME = 0, QTDOAEFECPME = 0, IDCARDESPEC = 'S'
                                WHERE CDFILCENTPME = P_CDCENTRAL AND NRCARDPME = P_NRCARDPME AND NRCARDIAPME = V_NRCARDIAPMENOVO AND CDSERVFILI = P_CDSERVFILI AND CDFILIAL = C_REALOC.CDFILIAL;

                                SELECT NRSEQCNFCPME, NRORDCNFCPME, NRSEQTMPCOMESPPRATPME
                                    INTO V_NRSEQCNFCPME, V_NRORDCNFCPME, V_NRSEQTMP
                                FROM TMPCOMESPPRATPME T 
                                WHERE T.CDTMPCOMESPPRATPME = V_TMP
                                    AND T.CDREALCOMESPPRATPME = C_REALOC.CDREALCOMESPPRATPME
                                    AND T.CDFILCENTPME = C_REALOC.CDFILCENTPME
                                    AND T.CDFILIAL = C_REALOC.CDFILIAL
                                    AND T.CDTIPOCARD = C_REALOC.CDTIPOCARD
                                    AND T.CDTIPOPRAT_REF = C_REALOC.CDTIPOPRAT_REF
                                    AND T.CDPRATO_REF = C_REALOC.CDPRATO_REF
                                    AND T.CDFILAUXPRAT_REF = C_REALOC.CDFILAUXPRAT_REF
                                    AND T.CDCOMESPPRATPME = C_REALOC.CDCOMESPPRATPME
                                    AND T.CDTIPOPRAT_DEST = C_REALOC.CDTIPOPRAT_DEST
                                    AND T.CDPRATO_DEST = C_REALOC.CDPRATO_DEST
                                    AND T.CDFILAUXPRAT_DEST = C_REALOC.CDFILAUXPRAT_DEST
                                    AND T.DTCARDIA = C_DATAS.DTCARDIAPME;

                                V_HAS_PRATO_REF := 0;
                                V_CHANGED_COMENSAIS := 0;
                                /* INSERE OS PRATOS PLANEJADOS DA CENTRAL NA AGREGADA */ 
                                FOR C_PRATOS_PLANEJADOS IN (
                                    SELECT NRSEQPRACPME, CDFILAUXPRAT,
                                      CDPRATO, CDTIPOPRAT, VRPECONSCPME, NRORDPRACPME, P.NRCARDIAPME
                                        FROM CARDIAPME D
                                        JOIN COMPCARDPME P ON P.CDFILCENTPME = D.CDFILCENTPME
                                            AND P.NRCARDPME = D.NRCARDPME
                                            AND P.NRCARDIAPME = D.NRCARDIAPME
                                            --AND P.CDPRATO <> C_REALOC.CDPRATO_DEST
                                            --AND P.CDFILAUXPRAT <> C_REALOC.CDFILAUXPRAT_DEST 
                                    WHERE D.CDFILCENTPME = P_CDCENTRAL
                                    AND D.NRCARDPME = P_NRCARDPME
                                    AND D.CDFILIAL = P_CDCENTRAL
                                    AND D.CDSERVFILI = P_CDSERVFILI
                                    AND DTCARDIAPME = C_DATAS.DTCARDIAPME
                                ) LOOP

                                    IF (C_PRATOS_PLANEJADOS.CDTIPOPRAT = C_REALOC.CDTIPOPRAT_REF AND C_PRATOS_PLANEJADOS.CDPRATO = C_REALOC.CDPRATO_REF AND 
                                        C_PRATOS_PLANEJADOS.CDFILAUXPRAT = C_REALOC.CDFILAUXPRAT_REF) THEN
                                        V_HAS_PRATO_REF := 1;
                                        IF ((((C_PRATOS_PLANEJADOS.VRPECONSCPME * V_QTCOMESTC) / 100) - C_REALOC.QTCOMESPRAT) < 0) THEN
                                            V_QTCOMENSAIS := 0;
                                        ELSE
                                            V_QTCOMENSAIS := ((((C_PRATOS_PLANEJADOS.VRPECONSCPME * V_QTCOMESTC) / 100) - C_REALOC.QTCOMESPRAT) / V_QTCOMESTC) * 100;
                                        END IF;

                                    END IF;

                                    IF (C_PRATOS_PLANEJADOS.CDTIPOPRAT = C_REALOC.CDTIPOPRAT_DEST AND C_PRATOS_PLANEJADOS.CDPRATO = C_REALOC.CDPRATO_DEST AND 
                                        C_PRATOS_PLANEJADOS.CDFILAUXPRAT = C_REALOC.CDFILAUXPRAT_DEST) THEN
                                        /* Caso o prato planejado seja o prato a ser realocado, trata para inserir os dados da realocação 
                                            apenas caso o parâmetro de pratos seja para sobrepor */

                                        IF (P_IDPRATOS = 'S') THEN
                                            SELECT COUNT(*)
                                                INTO V_COUNTTPPRAT
                                            FROM CONFCARDPME C
                                                WHERE CDFILCENTPME = P_CDCENTRAL
                                                 AND NRCARDPME    = P_NRCARDPME
                                                 AND CDSERVFILI   = P_CDSERVFILI
                                                 AND CDTIPOPRAT   = C_REALOC.CDTIPOPRAT_DEST
                                                 AND NRSEQCNFCPME = V_NRSEQCNFCPME
                                                 AND NRORDCNFCPME = V_NRORDCNFCPME;

                                            IF (V_COUNTTPPRAT = 0) THEN
                                                UPDATE CONFCARDPME SET NRORDCNFCPME = NRORDCNFCPME + 1 WHERE CDFILCENTPME = P_CDCENTRAL
                                                    AND NRCARDPME = P_NRCARDPME AND CDSERVFILI = P_CDSERVFILI 
                                                    AND NRORDCNFCPME >= V_NRORDCNFCPME;
                                                UPDATE COMPCARDPME SET NRORDPRACPME = NRORDPRACPME + 1 
                                                    WHERE CDFILCENTPME = P_CDCENTRAL AND NRCARDPME = P_NRCARDPME
                                                        AND NRORDPRACPME >= V_NRORDCNFCPME;

                                                INSERT INTO CONFCARDPME (CDFILCENTPME, NRCARDPME, CDSERVFILI, NRSEQCNFCPME, CDTIPOPRAT, IDOPCCNFCPME, IDIMPCNFCPME, NRORDCNFCPME)
                                                    VALUES (P_CDCENTRAL, P_NRCARDPME, P_CDSERVFILI, V_NRSEQCNFCPME, C_REALOC.CDTIPOPRAT_DEST, 'N', 'S', V_NRORDCNFCPME);
                                            END IF;
                                            INSERT INTO COMPCARDPME
                                               (CDFILCENTPME, NRCARDPME, NRCARDIAPME, NRSEQPRACPME, CDFILAUXPRAT, CDPRATO, VRPECONSCPME, CDTIPOPRAT, NRORDPRACPME, IDPRATREALOC)
                                            VALUES (P_CDCENTRAL, P_NRCARDPME, V_NRCARDIAPMENOVO, V_NRSEQCNFCPME, C_REALOC.CDFILAUXPRAT_DEST, C_REALOC.CDPRATO_DEST,
                                                (C_REALOC.QTCOMESPRAT / V_QTCOMESTC) * 100,
                                                C_REALOC.CDTIPOPRAT_DEST, V_NRORDCNFCPME, 'S');

                                            V_CHANGED_COMENSAIS := 1;
                                        END IF;

                                    ELSE 

                                        INSERT INTO COMPCARDPME (CDFILCENTPME, NRCARDPME, NRCARDIAPME, NRSEQPRACPME, CDFILAUXPRAT,
                                          CDPRATO, CDTIPOPRAT, VRPECONSCPME, NRORDPRACPME, IDPRATREALOC)
                                         VALUES (P_CDCENTRAL, P_NRCARDPME, V_NRCARDIAPMENOVO, C_PRATOS_PLANEJADOS.NRSEQPRACPME, C_PRATOS_PLANEJADOS.CDFILAUXPRAT,
                                              C_PRATOS_PLANEJADOS.CDPRATO, C_PRATOS_PLANEJADOS.CDTIPOPRAT, C_PRATOS_PLANEJADOS.VRPECONSCPME, C_PRATOS_PLANEJADOS.NRORDPRACPME, 'N');

                                    END IF;

                                END LOOP;

                                /* Se após inserir os pratos planejados na central, o prato a ser realocado ainda não tiver sido inserido
                                    (quando o mesmo não está planejado na central), insere ele */

                                IF (V_CHANGED_COMENSAIS = 0 AND V_HAS_PRATO_REF = 1) THEN 
                                    SELECT COUNT(*)
                                        INTO V_COUNTTPPRAT
                                    FROM CONFCARDPME C
                                        WHERE CDFILCENTPME = P_CDCENTRAL
                                         AND NRCARDPME    = P_NRCARDPME
                                         AND CDSERVFILI   = P_CDSERVFILI
                                         AND CDTIPOPRAT   = C_REALOC.CDTIPOPRAT_DEST
                                         AND NRSEQCNFCPME = V_NRSEQCNFCPME
                                         AND NRORDCNFCPME = V_NRORDCNFCPME;
                                    IF (V_COUNTTPPRAT = 0) THEN
                                        --NRSEQCNFCPME = NRSEQCNFCPME + 1, 
                                        UPDATE CONFCARDPME SET NRORDCNFCPME = NRORDCNFCPME + 1 WHERE CDFILCENTPME = P_CDCENTRAL
                                                    AND NRCARDPME = P_NRCARDPME
                                                    AND CDSERVFILI = P_CDSERVFILI
                                                    AND NRORDCNFCPME >= V_NRORDCNFCPME;
                                        --NRSEQPRACPME = NRSEQPRACPME + 1, 
                                        UPDATE COMPCARDPME SET NRORDPRACPME = NRORDPRACPME + 1 
                                                    WHERE CDFILCENTPME = P_CDCENTRAL AND NRCARDPME = P_NRCARDPME
                                                        AND NRORDPRACPME >= V_NRORDCNFCPME;

                                        INSERT INTO CONFCARDPME (CDFILCENTPME, NRCARDPME, CDSERVFILI, NRSEQCNFCPME, CDTIPOPRAT, IDOPCCNFCPME, IDIMPCNFCPME, NRORDCNFCPME)
                                            VALUES (P_CDCENTRAL, P_NRCARDPME, P_CDSERVFILI, V_NRSEQCNFCPME, C_REALOC.CDTIPOPRAT_DEST, 'N', 'S', V_NRORDCNFCPME);
                                    END IF;
                                    INSERT INTO COMPCARDPME
                                       (CDFILCENTPME, NRCARDPME, NRCARDIAPME, NRSEQPRACPME, CDFILAUXPRAT, CDPRATO, VRPECONSCPME, CDTIPOPRAT, NRORDPRACPME, IDPRATREALOC)
                                    VALUES (P_CDCENTRAL, P_NRCARDPME, V_NRCARDIAPMENOVO, V_NRSEQCNFCPME, C_REALOC.CDFILAUXPRAT_DEST, C_REALOC.CDPRATO_DEST,
                                        (C_REALOC.QTCOMESPRAT / V_QTCOMESTC) * 100, C_REALOC.CDTIPOPRAT_DEST, V_NRORDCNFCPME, 'S');

                                    V_CHANGED_COMENSAIS := 1;

                                END IF;


                                /* Se o comensal do prato tiver sido alterado */
                                /* REMOVIDO: e eles não possuírem o mesmo tipo de prato atualiza os comensais do prato referencia */
                                --AND C_REALOC.CDTIPOPRAT_REF <> C_REALOC.CDTIPOPRAT_DEST
                                IF (V_CHANGED_COMENSAIS = 1 ) THEN

                                    /* Grava cardia de destino para gerar log */
                                    UPDATE TMPCOMESPPRATPME 
                                        SET NRCARDIAPMEDEST = V_NRCARDIAPMENOVO
                                    WHERE CDTMPCOMESPPRATPME = V_TMP
                                        AND NRSEQTMPCOMESPPRATPME = V_NRSEQTMP;

                                    UPDATE COMPCARDPME
                                        SET VRPECONSCPME = V_QTCOMENSAIS
                                        WHERE 
                                       CDFILCENTPME = P_CDCENTRAL AND
                                        NRCARDPME = P_NRCARDPME AND
                                        NRCARDIAPME = V_NRCARDIAPMENOVO AND
                                        --NRSEQPRACPME = C_PRATOS.NRSEQPRACPME AND
                                        CDFILAUXPRAT = C_REALOC.CDFILAUXPRAT_REF AND
                                        CDPRATO = C_REALOC.CDPRATO_REF AND
                                        CDTIPOPRAT = C_REALOC.CDTIPOPRAT_REF;
                                        --AND
                                        --NRORDPRACPME = C_PRATOS.NRORDPRACPME;
                                END IF; 

                                /* ATUALIZA COMENSAIS DO DIA NA CENTRAL */
                            END IF;
                        ELSE 
                            /* Caso exista cardápio específico */

                            /* PERCORRE PRATOS ORIGEM NO DIA  */
                            FOR C_PRATOS IN (
                                SELECT
                                    P.NRCARDPME, P.NRCARDIAPME, P.CDPRATO, P.CDFILAUXPRAT, P.VRPECONSCPME, P.NRORDPRACPME, P.NRSEQPRACPME 
                                FROM COMPCARDPME P 
                                WHERE
                                    P.CDFILCENTPME = P_CDCENTRAL
                                    AND P.NRCARDPME = P_NRCARDPME
                                    AND P.NRCARDIAPME = V_EXISTNRCARDIAPME
                                    AND P.CDPRATO = C_REALOC.CDPRATO_REF
                                    AND P.CDFILAUXPRAT = C_REALOC.CDFILAUXPRAT_REF
                                    AND P.CDTIPOPRAT = C_REALOC.CDTIPOPRAT_REF
                                ORDER BY
                                    P.NRCARDPME, P.NRCARDIAPME, P.CDPRATO, P.CDFILAUXPRAT,  P.NRSEQPRACPME, P.NRORDPRACPME
                            ) LOOP

                                BEGIN
                                    SELECT NRSEQCNFCPME, NRORDCNFCPME, NRSEQTMPCOMESPPRATPME
                                        INTO V_NRSEQCNFCPME, V_NRORDCNFCPME, V_NRSEQTMP
                                    FROM TMPCOMESPPRATPME T 
                                    WHERE T.CDTMPCOMESPPRATPME = V_TMP
                                        AND T.CDREALCOMESPPRATPME = C_REALOC.CDREALCOMESPPRATPME
                                        AND T.CDFILCENTPME = C_REALOC.CDFILCENTPME
                                        AND T.CDFILIAL = C_REALOC.CDFILIAL
                                        AND T.CDTIPOCARD = C_REALOC.CDTIPOCARD
                                        AND T.CDTIPOPRAT_REF = C_REALOC.CDTIPOPRAT_REF
                                        AND T.CDPRATO_REF = C_REALOC.CDPRATO_REF
                                        AND T.CDFILAUXPRAT_REF = C_REALOC.CDFILAUXPRAT_REF
                                        AND T.CDCOMESPPRATPME = C_REALOC.CDCOMESPPRATPME
                                        AND T.CDTIPOPRAT_DEST = C_REALOC.CDTIPOPRAT_DEST
                                        AND T.CDPRATO_DEST = C_REALOC.CDPRATO_DEST
                                        AND T.CDFILAUXPRAT_DEST = C_REALOC.CDFILAUXPRAT_DEST
                                        AND T.DTCARDIA = C_DATAS.DTCARDIAPME;
                                EXCEPTION
                                    WHEN NO_DATA_FOUND THEN
                                        CONTINUE;
                                END;

                                V_CHANGED_COMENSAIS := 0;

                                /* Verifica se possui prato cadastrado para o tipo de prato */
                                V_EXISTPRATO := NULL;
                                BEGIN
                                  SELECT CDPRATO, NRSEQPRACPME, NRORDPRACPME, IDPRATREALOC
                                    INTO V_EXISTPRATO, V_NRSEQPRACPME, V_NRORDPRACPME, V_IDPRATREALOC
                                    FROM COMPCARDPME
                                    WHERE CDFILCENTPME = P_CDCENTRAL
                                    AND NRCARDPME = P_NRCARDPME
                                    AND NRCARDIAPME = C_PRATOS.NRCARDIAPME
                                    AND CDTIPOPRAT = C_REALOC.CDTIPOPRAT_DEST
                                    AND NRSEQPRACPME = V_NRSEQCNFCPME
                                    AND NRORDPRACPME = V_NRORDCNFCPME;
                                    --AND CDPRATO = C_REALOC.CDPRATO_DEST
                                    --AND CDFILAUXPRAT = C_REALOC.CDFILAUXPRAT_DEST;
                                EXCEPTION
                                  WHEN NO_DATA_FOUND THEN
                                     V_EXISTPRATO := NULL;
                                END;

                                /* Considera parâmetro de pratos da tela que define se irá sobrepor ou acrescentar */
                                IF (V_EXISTPRATO IS NULL) THEN
                                    SELECT COUNT(*)
                                    INTO V_COUNTTPPRAT
                                    FROM CONFCARDPME C
                                        WHERE CDFILCENTPME = P_CDCENTRAL
                                         AND NRCARDPME    = P_NRCARDPME
                                         AND CDSERVFILI   = P_CDSERVFILI
                                         AND CDTIPOPRAT   = C_REALOC.CDTIPOPRAT_DEST
                                         AND NRSEQCNFCPME = V_NRSEQCNFCPME
                                         AND NRORDCNFCPME = V_NRORDCNFCPME;
                                    IF (V_COUNTTPPRAT = 0) THEN
                                         --NRSEQCNFCPME = NRSEQCNFCPME + 1, 
                                        UPDATE CONFCARDPME SET NRORDCNFCPME = NRORDCNFCPME + 1 WHERE CDFILCENTPME = P_CDCENTRAL
                                                    AND NRCARDPME = P_NRCARDPME
                                                    AND CDSERVFILI = P_CDSERVFILI
                                                    AND NRORDCNFCPME >= V_NRORDCNFCPME;
                                        --NRSEQPRACPME = NRSEQPRACPME + 1,
                                        UPDATE COMPCARDPME SET  NRORDPRACPME = NRORDPRACPME + 1 
                                                    WHERE CDFILCENTPME = P_CDCENTRAL AND NRCARDPME = P_NRCARDPME
                                                        AND NRORDPRACPME >= V_NRORDCNFCPME;

                                        INSERT INTO CONFCARDPME (CDFILCENTPME, NRCARDPME, CDSERVFILI, NRSEQCNFCPME, CDTIPOPRAT, IDOPCCNFCPME, IDIMPCNFCPME, NRORDCNFCPME)
                                            VALUES (P_CDCENTRAL, P_NRCARDPME, P_CDSERVFILI, V_NRSEQCNFCPME, C_REALOC.CDTIPOPRAT_DEST, 'N', 'S', V_NRORDCNFCPME);
                                    END IF;
                                    INSERT INTO COMPCARDPME
                                       (CDFILCENTPME, NRCARDPME, NRCARDIAPME, NRSEQPRACPME, CDFILAUXPRAT, CDPRATO, VRPECONSCPME, CDTIPOPRAT, NRORDPRACPME, IDPRATREALOC)
                                    VALUES (P_CDCENTRAL, P_NRCARDPME, C_PRATOS.NRCARDIAPME, V_NRSEQCNFCPME, C_REALOC.CDFILAUXPRAT_DEST, C_REALOC.CDPRATO_DEST,
                                        (C_REALOC.QTCOMESPRAT / V_QTCOMESTC) * 100,
                                        C_REALOC.CDTIPOPRAT_DEST, V_NRORDCNFCPME, 'S');

                                    V_CHANGED_COMENSAIS := 1;

                                END IF;

                                IF (V_EXISTPRATO IS NOT NULL AND P_IDPRATOS = 'S' AND V_IDPRATREALOC = 'N') THEN
                                    UPDATE COMPCARDPME
                                        SET VRPECONSCPME = ((C_REALOC.QTCOMESPRAT / V_QTCOMESTC) * 100),
                                            CDPRATO = C_REALOC.CDPRATO_DEST,
                                            CDFILAUXPRAT = C_REALOC.CDFILAUXPRAT_DEST,
                                            IDPRATREALOC = 'S'
                                        WHERE 
                                       CDFILCENTPME = P_CDCENTRAL AND
                                        NRCARDPME = P_NRCARDPME AND
                                        NRCARDIAPME = C_PRATOS.NRCARDIAPME AND
                                        NRSEQPRACPME = V_NRSEQPRACPME AND
                                        --CDFILAUXPRAT = C_REALOC.CDFILAUXPRAT_DEST AND
                                        --CDPRATO = C_REALOC.CDPRATO_DEST AND
                                        CDTIPOPRAT = C_REALOC.CDTIPOPRAT_DEST AND
                                        NRORDPRACPME = V_NRORDPRACPME;

                                    V_CHANGED_COMENSAIS := 1;
                                END IF;

                                /*
                                IF (V_EXISTPRATO IS NOT NULL AND V_IDPRATREALOC = 'S') THEN
                                    DELETE FROM TMPCOMESPPRATPME 
                                    WHERE CDTMPCOMESPPRATPME = V_TMP
                                        AND NRSEQTMPCOMESPPRATPME = V_NRSEQTMP;

                                    UPDATE TMPCOMESPPRATPME T SET NRORDCNFCPME = NRORDCNFCPME - 1 
                                        WHERE T.CDTMPCOMESPPRATPME = V_TMP
                                            --AND T.CDREALCOMESPPRATPME = C_REALOC.CDREALCOMESPPRATPME
                                            AND T.CDFILCENTPME = C_REALOC.CDFILCENTPME
                                            AND T.CDFILIAL = C_REALOC.CDFILIAL
                                            AND T.CDTIPOCARD = C_REALOC.CDTIPOCARD
                                            AND NRORDCNFCPME >=  V_NRORDCNFCPME;
                                END IF;
                                */

                                IF (V_CHANGED_COMENSAIS = 1) THEN
                                    /* Grava cardia de destino para gerar log */
                                    UPDATE TMPCOMESPPRATPME 
                                        SET NRCARDIAPMEDEST = C_PRATOS.NRCARDIAPME
                                    WHERE CDTMPCOMESPPRATPME = V_TMP
                                        AND NRSEQTMPCOMESPPRATPME = V_NRSEQTMP;

                                    /* Comensais insuficientes no prato de referência deve zerar e manter os pratos com as qtds realocadas dos comensais. */
                                    IF ((((C_PRATOS.VRPECONSCPME * V_QTCOMESTC) / 100) - C_REALOC.QTCOMESPRAT) < 0) THEN
                                        V_QTCOMENSAIS := 0;
                                    ELSE
                                        -- V_QTCOMENSAIS := (((C_PRATOS.VRPECONSCPME / 100) * V_QTCOMESTC) - C_REALOC.QTCOMESPRAT);
                                        V_QTCOMENSAIS := ((((C_PRATOS.VRPECONSCPME * V_QTCOMESTC) / 100) - C_REALOC.QTCOMESPRAT) / V_QTCOMESTC) * 100;
                                    END IF;

                                    /* Retira os comensais do prato de referência */
                                    UPDATE COMPCARDPME
                                    SET
                                        -- VRPECONSCPME = (V_QTCOMENSAIS / V_QTCOMESTC) * 100
                                        VRPECONSCPME = V_QTCOMENSAIS
                                    WHERE
                                        CDFILCENTPME = C_REALOC.CDFILCENTPME
                                        AND NRCARDPME = C_PRATOS.NRCARDPME
                                        AND NRCARDIAPME = C_PRATOS.NRCARDIAPME
                                        AND CDPRATO = C_REALOC.CDPRATO_REF
                                        AND CDFILAUXPRAT = C_REALOC.CDFILAUXPRAT_REF
                                        AND CDTIPOPRAT = C_REALOC.CDTIPOPRAT_REF
                                        AND NRSEQPRACPME = C_PRATOS.NRSEQPRACPME
                                        AND NRORDPRACPME = C_PRATOS.NRORDPRACPME;
                                END IF;  
                            END LOOP;
                        END IF;

                        /*Atualiza comensais da central*/		
                        BEGIN
                           SELECT SUM(CD.QTCOMESTCPME), SUM(CD.QTCLIESTCPME), SUM(CD.QTFUNESTCPME), SUM(CD.QTDOAESTCPME)
                             INTO V_QTCOMESTCPME, V_QTCLIESTCPME, V_QTFUNESTCPME, V_QTDOAESTCPME
                             FROM CARDIAPME CD
                            WHERE
                                 (CD.CDFILCENTPME = P_CDCENTRAL) AND
                                 (CD.NRCARDPME    = P_NRCARDPME   ) AND
                                 (CD.CDSERVFILI   = P_CDSERVFILI   ) AND
                                 (CD.CDFILIAL     <> P_CDCENTRAL) AND
                                 (CD.DTCARDIAPME  = C_DATAS.DTCARDIAPME ) AND
                                 (CD.IDCARDESPEC  <> 'S');
                        EXCEPTION
                           WHEN NO_DATA_FOUND THEN
                              V_QTCOMESTCPME := 0;
                              V_QTCLIESTCPME := 0;
                              V_QTFUNESTCPME := 0;
                              V_QTDOAESTCPME := 0;
                        END;					

                        UPDATE CARDIAPME CA
                           SET
                              QTCOMESTCPME = V_QTCOMESTCPME,							
                              QTCLIESTCPME = V_QTCLIESTCPME,							
                              QTFUNESTCPME = V_QTFUNESTCPME,
                              QTDOAESTCPME = V_QTDOAESTCPME
                           WHERE
                              (CA.CDFILCENTPME = P_CDCENTRAL     ) AND
                              (CA.NRCARDPME    = P_NRCARDPME     ) AND
                              (CA.CDSERVFILI   = P_CDSERVFILI    ) AND
                              (CA.CDFILIAL     = CA.CDFILCENTPME ) AND
                              (CA.DTCARDIAPME  = C_DATAS.DTCARDIAPME);

                    END LOOP;

                END IF;
            END IF;
        END IF;

    END LOOP;

    /* Insere tabela temporária na tabela de log */
    FOR TMP IN (
        SELECT CDTMPCOMESPPRATPME, NRSEQTMPCOMESPPRATPME, CDREALCOMESPPRATPME, CDFILCENTPME, CDFILIAL, CDTIPOCARD, CDTIPOPRAT_REF, CDPRATO_REF, CDFILAUXPRAT_REF, NRSEQPRACPME_REF,
                    CDCOMESPPRATPME, CDTIPOPRAT_DEST, CDPRATO_DEST, CDFILAUXPRAT_DEST, QTCOMESPRAT, NRSEQCNFCPME, NRORDCNFCPME, DTCARDIA, NRCARDIAPMEORI, NRCARDIAPMEDEST
        FROM TMPCOMESPPRATPME WHERE CDTMPCOMESPPRATPME = V_TMP AND NRCARDIAPMEDEST IS NOT NULL
    ) LOOP
        INSERT INTO LOGREACOMESPPRATPME(
			CDFILCENTPME, DTPROC, CDFILIAL, CDTIPOCARD, NRCARDPME, CDSERVFILI, 
			DTCARDIAPME, NRCARDIAPMEORI, CDTIPOPRATORI, CDPRATOORI, 
            CDFILAUXPRATORI, NRSEQCONFORI, NRCARDIAPMEDEST, CDTIPOPRATDEST, CDPRATODEST, CDFILAUXPRATDEST, 
			NRSEQCONFDEST, QTCOMENSAISDEST, CDOPERINCLUSAO, DTINCLUSAO)
        VALUES(
			TMP.CDFILCENTPME, V_DTPROC, TMP.CDFILIAL, TMP.CDTIPOCARD, P_NRCARDPME, P_CDSERVFILI, 
			TMP.DTCARDIA, TMP.NRCARDIAPMEORI, TMP.CDTIPOPRAT_REF, TMP.CDPRATO_REF,
            TMP.CDFILAUXPRAT_REF, TMP.NRSEQPRACPME_REF, TMP.NRCARDIAPMEDEST, TMP.CDTIPOPRAT_DEST, TMP.CDPRATO_DEST, TMP.CDFILAUXPRAT_DEST, 
			TMP.NRSEQCNFCPME, TMP.QTCOMESPRAT, P_CDOPERADOR, SYSDATE);
    END LOOP;

    /* Deleta registros da tabela temporária que foram inclusos a mais de 7 dias, para manter log das execuções */
    DELETE FROM TMPCOMESPPRATPME WHERE DTINCLUSAO < TRUNC(SYSDATE) - 7;

	IF (NVL(V_NRLOGINTCARD, '') <> '') THEN
		P_NRLOGINTCARD := NVL(V_NRLOGINTCARD, '');
	END IF;

    COMMIT;
    RETURN;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('REALOCAR_COMENSAIS_ESP_PAE','X.XX.XXX'); END;
/
