CREATE OR REPLACE PROCEDURE ORCAMENTO_CENTCUST_OK(P_CDEMPRESA EMPRESA.CDEMPRESA%TYPE,
                                                  P_CDFILIAL  FILIAL.CDFILIAL%TYPE,
                                                  P_CDCLASSFINA CLASSFINANC.CDCLASSFINA%TYPE,
                                                  P_CDCENTCUST CENTCUST.CDCENTCUST%TYPE,
                                                  P_DTLANCAMENTO DATE,
                                                  P_VRVALOR NUMBER,
                                                  P_RESULTADO OUT NUMBER,
												  P_ORIG VARCHAR2 DEFAULT 'PAG')
AS
   V_IDCONSORCFIN VARCHAR2(1);
   V_IDTPORCAFINA VARCHAR2(1);
   V_DTINIMES DATE;
   V_DTFINMES DATE;
   V_DTINICONSORCA DATE;
   V_CDFILIAL VARCHAR2(4);
   V_ENTROU BOOLEAN := FALSE;
   V_IDTIPOORCA VARCHAR2(1);
BEGIN
   /*VERIFICA PARAMETRIZAO GERAL SOBRE ORAMENTO FINANCEIRO*/
   SELECT IDCONSORCFIN, IDTPORCAFINA
     INTO V_IDCONSORCFIN, V_IDTPORCAFINA
     FROM PARAMGERAL;
   SELECT NVL(IDTIPOORCA,'T') AS IDTIPOORCA
     INTO V_IDTIPOORCA
     FROM GERPARAMGERAL;
   SELECT DTINICONSORCA
     INTO V_DTINICONSORCA
	   FROM GERAL_PAG;
   /*VERIFICA SE CONSISTE OU NO ORAMENTO FINANCEIRO*/
   IF (V_IDCONSORCFIN = 'S') AND (P_VRVALOR <> 0) AND (V_IDTIPOORCA = 'C') THEN
      /*VERIFICA SE O TIPO DE ORAMENTO  POR FILIAL*/
      IF V_IDTPORCAFINA = 'F' THEN
         V_CDFILIAL := P_CDFILIAL;
      ELSE
         V_CDFILIAL := NULL;
      END IF;
      V_DTINIMES := TO_DATE('01' || TO_CHAR(P_DTLANCAMENTO, 'MMYYYY'), 'DDMMYYYY');
      V_DTFINMES := LAST_DAY(P_DTLANCAMENTO);
      FOR C_ORCAFIN IN (SELECT CDEMPRESA,
                               CDFILIAL,
                               CDCENTCUST,
                               DTORCAFINA,
                               NVL(VRORCAFINA, 0) VRORCAFINA,
                               NVL(VREXTOLEORCA, 0) VREXTOLEORCA,
                               NVL(VRREALORCA, 0) VRREALORCA
                          FROM ORCAFINACENTCUST
                         WHERE (CDEMPRESA   = P_CDEMPRESA)   AND
                               (CDFILIAL    = NVL(V_CDFILIAL, CDFILIAL)) AND
                               (CDCENTCUST  = P_CDCENTCUST) AND
                               (CDCLASSFINA = P_CDCLASSFINA) AND
                               (DTORCAFINA BETWEEN V_DTINIMES AND V_DTFINMES)) LOOP
         V_ENTROU := TRUE;                      
         /*VERIFICA SE O VALOR ORADO SER ULTRAPASSADO*/
         IF ROUND(C_ORCAFIN.VRREALORCA + P_VRVALOR, 2) > ROUND(C_ORCAFIN.VRORCAFINA + C_ORCAFIN.VREXTOLEORCA, 2) AND ((P_ORIG <> 'PAG') OR (V_DTINICONSORCA IS NOT NULL)) THEN
            P_RESULTADO := 0;
            RETURN;
         END IF;
         /*ATUALIZA O VALOR DO ORAMENTO J UTILIZADO*/
         UPDATE ORCAFINACENTCUST
            SET VRREALORCA  = ROUND(C_ORCAFIN.VRREALORCA + P_VRVALOR, 2)
          WHERE CDEMPRESA   = P_CDEMPRESA AND
                CDCENTCUST  = P_CDCENTCUST AND
                CDCLASSFINA = P_CDCLASSFINA AND
                CDFILIAL    =  NVL(V_CDFILIAL, CDFILIAL) AND
                DTORCAFINA  = C_ORCAFIN.DTORCAFINA;
      END LOOP;
      IF (V_ENTROU = FALSE) AND ((P_ORIG <> 'PAG') OR (V_DTINICONSORCA IS NOT NULL)) THEN
         P_RESULTADO := 0;
         RETURN;
      END IF;
   END IF;
   P_RESULTADO := 1;
END;