create or replace PROCEDURE VERIFICA_VALIDADE(
    P_CDPRODUTO    IN PRODUTO.CDPRODUTO%TYPE,
    P_CDPRECOBASE  IN PRECOBASE.CDPRECOBASE%TYPE,
    P_CDOPERATZIPB  IN ITEMPREBASE.CDOPERATZIPB%TYPE
) AS
    V_DTFINPB            ITEMPREBASE.DTFIMVALIPB%TYPE;-- data final itemprebase
    V_DTINIPB            ITEMPREBASE.DTINIVALIPB%TYPE;-- data inicicial itemprebase
    V_NVDATAFIN          ITEMPREBASE.DTFIMVALIPB%TYPE;-- Nova data final
    V_NVDATAINI          ITEMPREBASE.DTINIVALIPB%TYPE;-- Nova data inicicial
    V_EDDATAFIN          ITEMPREBASE.DTFIMVALIPB%TYPE;-- data final que esta sendo editada
    V_EDDATAINI          ITEMPREBASE.DTINIVALIPB%TYPE;-- data inicicial que esta sendo editada
    V_NRSEQ              RELACITEMPBASE.NRSEQRELACPB%TYPE;
    V_NVPBASE            ITEMPREBASE.VRITEPREBASE%TYPE;
    V_IDULTPRECPROMO     PRECOBASE.IDULTPRECPROMO%TYPE;
    V_RESULTADO          VARCHAR2(2) := '00'; 
    V_REGFILHO           NUMBER;
    V_EXISTREG           NUMBER;
    V_ERROEDIT           VARCHAR2(2);
BEGIN

    --Busca o IDULTPRECPROMO da tabela PRECOBASE
    SELECT IDULTPRECPROMO
        INTO V_IDULTPRECPROMO
    FROM PRECOBASE
    WHERE CDPRECOBASE = P_CDPRECOBASE;
     -- verifica se aquele produto  possui registro filho na tabela OPCIOPRBASE e PROMOPRBASE de acordo como tipo de tabela de preo
     -- Contagem de filhos
    IF V_IDULTPRECPROMO = 'N' THEN
        SELECT COUNT(*)
            INTO V_REGFILHO
        FROM OPCIOPRBASE
        WHERE CDPRECOBASE = P_CDPRECOBASE
         AND CDPRODUTO = P_CDPRODUTO;
    ELSE
        SELECT COUNT(*)
            INTO V_REGFILHO
        FROM PROMOPRBASE
        WHERE CDPRECOBASE = P_CDPRECOBASE
        AND CDPRODUTO = P_CDPRODUTO;
    END IF;
       
    -- faz um loop na tabela temporria de validades
    FOR C_VALIDADE_EDIT IN (
        SELECT R1.CDPRODUTO,
       R1.CDPRECOBASE,
       R1.NRSEQRELACPB,
       R1.DTINIVALIPB,
       R1.DTFIMVALIPB,
       R1.DTINICHANGE,
       R1.DTFIMCHANGE,
       R1.VRITEPREBASE,
       CASE
           WHEN EXISTS (
               SELECT 1
               FROM RELACITEMPBASE R2
               WHERE R2.CDPRODUTO = R1.CDPRODUTO
                 AND R2.CDPRECOBASE = R1.CDPRECOBASE
                 AND R2.NRSEQRELACPB <> R1.NRSEQRELACPB
                 AND (R1.DTFIMVALIPB IS NOT NULL AND R2.DTFIMVALIPB IS NOT NULL) 
                 AND R1.DTINIVALIPB >= R2.DTINIVALIPB
                 AND R1.DTFIMVALIPB <= R2.DTFIMVALIPB
           ) THEN 'E1' -- As validades esto contidas em outras validade editadas
           WHEN EXISTS (
               SELECT 1
               FROM RELACITEMPBASE R2
               WHERE R2.CDPRODUTO = R1.CDPRODUTO
                 AND R2.CDPRECOBASE = R1.CDPRECOBASE
                 AND R2.NRSEQRELACPB <> R1.NRSEQRELACPB
                 AND (R1.DTFIMVALIPB IS NOT NULL AND R2.DTFIMVALIPB IS NOT NULL) 
                 AND R1.DTFIMVALIPB >= R2.DTINIVALIPB
                 AND R1.DTFIMVALIPB <= R2.DTFIMVALIPB
           ) THEN 'E2' -- A data final editada est contida em outra validade     
           WHEN EXISTS (
               SELECT 1
               FROM RELACITEMPBASE R2
               WHERE R2.CDPRODUTO = R1.CDPRODUTO
                 AND R2.CDPRECOBASE = R1.CDPRECOBASE
                 AND R2.NRSEQRELACPB <> R1.NRSEQRELACPB
                 AND (R1.DTFIMVALIPB IS NOT NULL AND R2.DTFIMVALIPB IS NOT NULL) 
                 AND R1.DTINIVALIPB >= R2.DTINIVALIPB
                 AND R1.DTINIVALIPB <= R2.DTFIMVALIPB
           ) THEN 'E3' -- Existe uma data inicial entre essa validade editada        
           WHEN EXISTS (
               SELECT 1
               FROM RELACITEMPBASE R2
               WHERE R2.CDPRODUTO = R1.CDPRODUTO
                 AND R2.CDPRECOBASE = R1.CDPRECOBASE
                 AND R2.NRSEQRELACPB <> R1.NRSEQRELACPB
                 AND R1.DTINIVALIPB <= R2.DTFIMVALIPB
                 AND R1.DTFIMVALIPB IS NULL 
           ) THEN 'E4' -- A validade aberta abrange outra validade cadastrada
           WHEN EXISTS (
               SELECT 1
               FROM RELACITEMPBASE R2
               WHERE R2.CDPRODUTO = R1.CDPRODUTO
                 AND R2.CDPRECOBASE = R1.CDPRECOBASE
                 AND R2.NRSEQRELACPB <> R1.NRSEQRELACPB
                 AND R1.DTINIVALIPB <> R2.DTFIMVALIPB
                 AND (R1.DTFIMVALIPB IS NULL AND R2.DTFIMVALIPB IS NULL) 
           ) THEN 'E5' -- Existem duas validades abertas cadastradas
           WHEN EXISTS (
               SELECT 1
               FROM RELACITEMPBASE R2
               WHERE R2.CDPRODUTO = R1.CDPRODUTO
                 AND R2.CDPRECOBASE = R1.CDPRECOBASE
                 AND R2.NRSEQRELACPB <> R1.NRSEQRELACPB
                 AND (R1.DTFIMVALIPB IS NOT NULL AND R1.DTINIVALIPB >= R1.DTFIMVALIPB)
           ) THEN 'E6' -- A data Final no pode ser menor ou igual  data inicial
           WHEN R1.DTFIMVALIPB IS NULL AND EXISTS (
               SELECT 1
               FROM RELACITEMPBASE R2
               WHERE R2.CDPRODUTO = R1.CDPRODUTO
                 AND R2.CDPRECOBASE = R1.CDPRECOBASE
                 AND R2.NRSEQRELACPB <> R1.NRSEQRELACPB
                 AND R2.DTFIMVALIPB IS NOT NULL
                 AND R2.DTFIMVALIPB >= R1.DTINIVALIPB
           ) THEN 'E7' -- Validade aberta no pode sobrepor outra validade existente com data final
           ELSE '00' 
       END AS DSERROEDIT
FROM RELACITEMPBASE R1
WHERE R1.CDPRODUTO = P_CDPRODUTO
  AND R1.CDPRECOBASE = P_CDPRECOBASE
    )LOOP
        V_ERROEDIT := C_VALIDADE_EDIT.DSERROEDIT;
		V_NVDATAFIN := C_VALIDADE_EDIT.DTFIMVALIPB;
        V_NVDATAINI := C_VALIDADE_EDIT.DTINIVALIPB;
        V_EDDATAFIN := C_VALIDADE_EDIT.DTFIMCHANGE;
        V_EDDATAINI := C_VALIDADE_EDIT.DTINICHANGE;
        V_NVPBASE   := C_VALIDADE_EDIT.VRITEPREBASE;
        V_NRSEQ     := C_VALIDADE_EDIT.NRSEQRELACPB;
        IF V_ERROEDIT <> '00' THEN
        /*Erros retornados do select  que iniciam com 'E' sinalizam conflitos apenas nas novas datas
         inseridas na edio, caso no haja erro de conflito  a validao  segue para demais datas da ITEMPREBASE que no sero editadas*/
                V_RESULTADO := V_ERROEDIT;
        ELSE

            
            IF V_NVDATAFIN IS NOT NULL AND V_NVDATAFIN <= V_NVDATAINI THEN
                V_RESULTADO := '01';-- A data final no pode ser menor ou igual a data inicial
            ELSE
                -- verifica se h  alterao da data inicial e se o produto possui registro filho
                IF V_NVDATAINI <> V_EDDATAINI AND V_REGFILHO >= 1 THEN
                    V_RESULTADO := '02';--Impossivel atualizar. Existem registros filhos
                ELSE
                    FOR C_VALID_ITEMPB IN (
                        SELECT DTINIVALIPB, DTFIMVALIPB
                        FROM ITEMPREBASE
                        WHERE CDPRODUTO = P_CDPRODUTO
                          AND CDPRECOBASE = P_CDPRECOBASE
                    ) LOOP
                        V_DTFINPB := C_VALID_ITEMPB.DTFIMVALIPB;
                        V_DTINIPB := C_VALID_ITEMPB.DTINIVALIPB;
                        -- Compara  demais datas de RELACITEMPBASE com ITEMPREBASE
                        IF  V_DTFINPB IS NULL AND V_DTINIPB <> V_EDDATAINI THEN
                            V_RESULTADO := '10'; -- A validade esta contida ou contm outra validade aberta
                        ELSE
                            IF (V_EDDATAFIN <> V_DTFINPB AND V_EDDATAINI <> V_DTINIPB) OR(V_EDDATAFIN IS NULL) OR (V_DTFINPB IS NULL AND V_NVDATAFIN IS NULL  AND V_DTINIPB <> V_NVDATAINI) THEN
                                IF V_NVDATAINI >= V_DTFINPB AND V_NVDATAINI <= V_DTINIPB THEN
                                    V_RESULTADO := '03'; -- Data de RELACITEMPBASE est contida em ITEMPREBASE
                                END IF;
                                
                                IF V_NVDATAFIN >= V_DTINIPB AND V_NVDATAFIN <= V_DTFINPB THEN
                                    V_RESULTADO := '04'; -- A data final no pode estar contida em outra validade
                                END IF;
                                
                                IF V_NVDATAINI >= V_DTINIPB AND V_NVDATAINI <= V_DTFINPB THEN
                                    V_RESULTADO := '05'; -- A data inicial est contida em outra validade
                                END IF;
                                
                                IF V_NVDATAINI <= V_DTINIPB AND V_NVDATAFIN IS NULL AND V_DTINIPB <> V_EDDATAINI THEN
                                    V_RESULTADO := '06'; -- Existem outras validades j cadastradas no perodo selecionado.
                                END IF;
                                
                                IF V_NVDATAINI >= V_DTINIPB AND V_DTFINPB IS NULL THEN
                                    IF V_DTINIPB = V_EDDATAINI THEN
                                        V_RESULTADO := '00'; -- Registro a atualizar
                                    ELSE
                                        V_RESULTADO := '07'; -- Existe uma validade em aberto
                                    END IF;
                                END IF;
                                
                                IF V_NVDATAINI <= V_DTINIPB AND V_DTINIPB <= V_NVDATAFIN AND V_EDDATAINI <> V_NVDATAINI THEN
                                    V_RESULTADO := '08'; -- Existe outra validade contida nesse intervalo
                                END IF;
                                
                                IF V_DTFINPB IS NULL AND V_NVDATAFIN >= V_DTINIPB AND V_EDDATAINI <> V_NVDATAINI THEN
                                    V_RESULTADO := '09'; -- A data final no pode estar contida em uma validade aberta
                                END IF;
                            END IF; 
                        END IF;
                    END LOOP;
                END IF;
            END IF;
        END IF;
        -- Atualizar o erro na tabela RELACITEMPBASE se no houver erro a ITEMPREBASE
        IF V_RESULTADO <> '00' THEN
            UPDATE RELACITEMPBASE
                SET DSERRO = V_RESULTADO
            WHERE NRSEQRELACPB = V_NRSEQ
                AND CDPRODUTO = P_CDPRODUTO
                 AND CDPRECOBASE = P_CDPRECOBASE;
        ELSE
            DELETE 
                FROM RELACITEMPBASE
            WHERE NRSEQRELACPB = V_NRSEQ
                AND CDPRODUTO = P_CDPRODUTO
                 AND CDPRECOBASE = P_CDPRECOBASE;
            SELECT COUNT(*)
                INTO V_EXISTREG
                FROM ITEMPREBASE
            WHERE CDPRODUTO = P_CDPRODUTO
                 AND CDPRECOBASE = P_CDPRECOBASE;
           IF V_EXISTREG  = 0 AND((V_EDDATAINI =  V_NVDATAINI AND  (V_EDDATAFIN = V_NVDATAFIN OR V_NVDATAFIN IS NULL))OR (V_EDDATAFIN IS NULL AND V_EDDATAINI IS NULL))THEN
                INSERT INTO ITEMPREBASE(CDPRODUTO, CDPRECOBASE, DTINIVALIPB, DTFIMVALIPB,DTHRATZIPB, CDOPERATZIPB,  VRITEPREBASE)
                VALUES (P_CDPRODUTO, P_CDPRECOBASE, V_NVDATAINI, V_NVDATAFIN, TRUNC(SYSDATE), P_CDOPERATZIPB,  V_NVPBASE);
           ELSE
               UPDATE ITEMPREBASE 
                    SET DTINIVALIPB = V_NVDATAINI, 
                        DTFIMVALIPB = V_NVDATAFIN,
                        VRITEPREBASE = V_NVPBASE
                WHERE (DTINIVALIPB = V_EDDATAINI AND (DTFIMVALIPB = V_EDDATAFIN OR DTFIMVALIPB IS NULL))
                    AND CDPRODUTO = P_CDPRODUTO
                     AND CDPRECOBASE = P_CDPRECOBASE;
           END IF;
        END IF;
	END LOOP;
END;
/
