CREATE TABLE INFORMATIVO_PERFILACESSO(
    CDINFORPERFACESS    NUMBER        NOT NULL,
    NRPERFILACESSO      NUMBER        NOT NULL,
    NRINFECOMMERCE      NUMBER        NOT NULL, 	
    NRORG             NUMBER 	      DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
    IDATIVO           VARCHAR2(1)     DEFAULT 'S'					NOT NULL,
    DTINCLUSAO        DATE            DEFAULT SYSDATE,
    DTULTATU          DATE            DEFAULT SYSDATE,
    NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1' 					NULL,
    NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERULTATU      VARCHAR2(12)    DEFAULT '1',
		CONSTRAINT PK_INFORMATIVO_PERFILACESSO PRIMARY KEY(CDINFORPERFACESS),
		CONSTRAINT CKC_IDATIVO_INFOR_PERFACESS CHECK (IDATIVO IN ('S','N')),
		CONSTRAINT FK_INFORMATIVO_PERFILACESSO FOREIGN KEY (NRPERFILACESSO) REFERENCES PERFILACESSO(NRPERFILACESSO),
		CONSTRAINT FK_INFORMATIVO_INFECOMMERCE FOREIGN KEY (NRINFECOMMERCE) REFERENCES INFORMATIVOECOMMERCE(NRINFECOMMERCE)
)
/
CREATE TABLE INFORMATIVO_PRODUTO(
    CDINFORPRODUTO      NUMBER        NOT NULL,
    NRPRODUTO           NUMBER        NOT NULL,
    NRINFECOMMERCE      NUMBER        NOT NULL, 	
    NRORG             NUMBER 	      DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
    IDATIVO           VARCHAR2(1)     DEFAULT 'S'					NOT NULL,
    DTINCLUSAO        DATE            DEFAULT SYSDATE,
    DTULTATU          DATE            DEFAULT SYSDATE,
    NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1' 					NULL,
    NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERULTATU      VARCHAR2(12)    DEFAULT '1',
		CONSTRAINT PK_INFORMATIVO_PRODUTO PRIMARY KEY(CDINFORPRODUTO),
		CONSTRAINT CKC_IDATIVO_INFOR_PRODUTO CHECK (IDATIVO IN ('S','N')),
		CONSTRAINT FK_INFORMATIVO_PRODUTO FOREIGN KEY (NRPRODUTO) REFERENCES OM_PRODUTO(ID),
		CONSTRAINT FK_PRODUTO_INFECOMMERCE FOREIGN KEY (NRINFECOMMERCE) REFERENCES INFORMATIVOECOMMERCE(NRINFECOMMERCE)
)
/