import { TekGrid } from '@zeedhi/teknisa-components-common';
import { Http, Metadata } from '@zeedhi/core';
import { LoadingService } from '@zeedhi/common';
import { OmDialogService } from '@/services/OmDialogService';

export class RedirecionamentoProdutoController {
  public async saveRedirecionamentoProduto(params: any) {
    LoadingService.show();
    params.event.preventDefault();
    const redirecionamentoRC = { rows: params.component.getEditedRows() };
    try {
      await Http.post('/saveRedirecionamentoProduto', redirecionamentoRC);
      params.component.cancelEditedRows();
      params.component.selectedRows = [];
      params.component.datasource.get();
      LoadingService.hide();
    } catch (e) {
      OmDialogService.showErrorBackend(e);
      LoadingService.hide();
    }
  }

  public async redirectForSelectedRows(params: any) {
    const stageRedirect = params.component.name === 'actionAdd' ? 'ADD' : 'REMOVE';
    const redirecionamentoGrid = Metadata.getInstance<TekGrid>('gridRedirecionamentoProduto');
    LoadingService.show();
    params.event.preventDefault();
    const redirecionamentoRCRows = { rows: redirecionamentoGrid.selectedRows, stageRedirect };
    try {
      await Http.post('/saveRedirecionamentoProduto', redirecionamentoRCRows);
      redirecionamentoGrid.cancelEditedRows();
      redirecionamentoGrid.selectedRows = [];
      redirecionamentoGrid.datasource.get();
      LoadingService.hide();
    } catch (e) {
      redirecionamentoGrid.reload();
      OmDialogService.showErrorBackend(e);
      LoadingService.hide();
    }
  }

  public getRedirecionamentoStyle(params: any) {
    if (params.row.IDUTREDIRECTRC === 'S') {
      return 'om-next-grid-bold';
    }
    return '';
  }

  public get visibleActionButton() {
    const gridModal = Metadata.getInstance<TekGrid>('gridRedirecionamentoProduto');
    if (gridModal.selectedRows.length > 0) {
      return false;
    }
    return true;
  }
}
